/*
 * RotaryEncoder.hpp
 *
 *  Created on: 30 de jan. de 2022
 *      Author: igor_
 */

//https://forum.arduino.cc/t/using-an-interrupt-from-a-method-inside-a-class/486521/12

#ifndef _ROTARYENCODER_HPP_
#define _ROTARYENCODER_HPP_

#include "driver/gpio.h"

static uint32_t enc_cnt;

/* ^^^^^^^^^^^^^
 * RotaryEncoder
 * ^^^^^^^^^^^^^ */
namespace RotaryEncoder {
class encoder;
} /* namespace RotaryEncoder */

// TB6612FNG type
using encoder_t = RotaryEncoder::encoder;

typedef struct {
	gpio_num_t enc1_pin;
	gpio_num_t enc2_pin;
	int interrupt;
} encoder_config_t;

typedef struct {
	gpio_num_t gpio_num;
	encoder_t* encoder_ptr;
} encoder_isr_config_t;

namespace RotaryEncoder {

class encoder {

public:
	static void inside_class_isr_handler(void* arg);

	gpio_num_t
		enc1_pin,
		enc2_pin;

	void encoder_init(encoder_config_t *enc_conf);

}; /* Class encoder */
} /* Namespace RotaryEncoder */

#endif /* ROTARYENCODER_SRC_ROTARYENCODER_HPP_ */
